#!/usr/bin/perl
# mkesxids.pl - make ESX-compatible XML file from pci.ids
#
print "<?xml version='1.0' encoding='iso-8859-1'?>\n";
print "<pcitable>\n";
print "  <moduleinfo class=\"00000000\" mask=\"00000000\">\n";
print "    <dependencies></dependencies>\n";
print "  </moduleinfo>\n";

$vendor = "";
while (<STDIN>) {
	chop($_);
	if (/^[0-9a-f]{4}/i) {
	# This is a vendor line
		if ($vendor != "") {
		# close out the existing vendor first
			print ("  </vendor>\n");
		}
		$vendor = substr($_,6);
		print ("  <vendor id=\"", substr($_,0,4), "\">\n");
		print ("    <short>$vendor</short>\n");
		print ("    <name>$vendor</name>\n");
	}
	if (/^\t[0-9a-f]{4}/i) {
	# This is a device ID line
		print("    <device id=\"",  substr($_,1,4), "\">\n");
		print("      <vmware label=\"nic\">\n");
		print("        <driver>igb</driver>\n");
		print("      </vmware>\n");
		print("      <table file=\"pcitable\" module=\"ignore\" />\n");
		print("      <table file=\"pcitable.Linux\"  data=\"00000000\" module=\"igb\">\n");
		print("        <desc>$vendor|", substr($_,7),"</desc>\n");
		print("      </table>\n");
		print("      <name>",substr($_,7),"</name>\n");
		print("    </device>\n");
	}
	# ignore all other lines
}
print ("  </vendor>\n");
print ("</pcitable>\n\n");
