Name: VMware-esx-drivers-net-igb
%define ESX_version 350
Summary: Intel(R) Gigabit Ethernet Connection driver for VMware ESX Server 3.5.0
Version: %{ESX_version}.1.3.19.15.4
Release: 159614
Source: VMware-esx-drivers-net-igb-%{version}.tar.gz
Vendor: Intel Corporation
License: GPL
# For high-level RPM tools
Group: Applications/Emulators
Provides: %{name}
URL: http://support.intel.com
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: vmware-hwdata >= 1.00
Requires: DriverAPI-8.0
# Obsoletes single driver rpm
Obsoletes: VMware-esx-drivers

%description
The igb driver enables support for products based on the Intel(R) 82575 and 82576 Gigabit Ethernet Controllers.

%prep
%setup

%build
mkdir -p %{buildroot}
mkdir -p /tmp/driver_sig/igb
make -C src clean
make -C src all
cp -v src/driver.sig /tmp/driver_sig/igb/driver.sig

%install
make -C src INSTALL_MOD_PATH=%{buildroot} MANDIR=%{_mandir} install
cd %{buildroot}
find . -name "igb.*o" -fprintf %{_builddir}/%{name}-%{version}/file.list "/%p\n"


%clean
rm -rf %{buildroot}

%files -f %{_builddir}/%{name}-%{version}/file.list
%defattr(-,root,root)
%doc COPYING
%doc README
%doc file.list
/etc/vmware/pciid/igb.xml

%post
/usr/sbin/esxcfg-pciid -q --boot
%preun
%postun
/usr/sbin/esxcfg-pciid -q --boot

